
\documentclass[10pt,  english, makeidx, a4paper, titlepage, oneside]{book}
\usepackage{babel}
\usepackage{fancyhdr}
\usepackage{makeidx}
\usepackage{titlesec}
\usepackage{booktabs}
\usepackage[T1]{fontenc}
\usepackage{lipsum}
\newenvironment{listato}{\footnotesize}{\normalsize }

%\pagestyle{empty}

\textwidth 15.5cm
\textheight 23cm
\topmargin -1cm
\oddsidemargin -0.5cm
\linespread{1.1}

\pagestyle{fancy}
\lhead{}
\chead{Microelectronic Systems}
\lfoot{}
\cfoot{}
\rfoot{}
\rhead{\thepage}

\usepackage{graphicx}
\usepackage{amsmath}
\usepackage{amsfonts}
\usepackage{amsthm}
\usepackage{amssymb}
%\oddsidemargin -1.1cm
\usepackage{graphicx}
\usepackage{float}
\usepackage{amsmath}
\usepackage{amssymb}
\usepackage{amsfonts}
\usepackage{amsthm}
\usepackage{subscript}
\usepackage{empheq}
\usepackage{verbatim}
\usepackage{fancyvrb}
\usepackage{tikz}
\usepackage{xcolor}
\usepackage[top=3cm, bottom=3cm,left=2cm,right=2cm]{geometry}

\usepackage{subcaption}
\usepackage{minted}
\usepackage[hidelinks]{hyperref}
\hypersetup{
	colorlinks   = true, %Colours links instead of ugly boxes
	urlcolor     = blue, %Colour for external hyperlinks
	linkcolor    = blue, %Colour of internal links
	citecolor   = red %Colour of citations
}

\titleformat{\chapter}[display]
{\normalfont\Large\filcenter\sffamily}
{\titlerule[0.5pt]%
\vspace{1pt}
\titlerule
\vspace{1pc}
\LARGE\MakeUppercase{\chaptertitlename} \thechapter
}
{1pc}
{\titlerule
\vspace{1pc}
\Huge}

\makeindex

\begin{document}

\frontmatter
\begin{titlepage}
\vspace{0cm}
\centerline{
\includegraphics[width=3cm]{./logopoli.jpg}} 
\vspace{0.5cm}
\centerline{\LARGE Politecnico di Torino}
\vspace{2.5cm}
\centerline{\huge\sf Microelectronic Systems}
\vspace{1cm}
\centerline{\Huge\sf DLX Microprocessor: Design \& Development}
\bigskip
\centerline{\huge\sf Final Project Report}
\vspace{2cm}
\centerline{\Large Master degree in Electronics Engineering}
\bigskip
\centerline{\Large Master degree in Computer Engineering}
\vspace{4.5cm}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
\centerline{\large Referents: Prof. Mariagrazia Graziano, Giulia Santoro}
\bigskip
\vspace{1cm}
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GROUP
% Change the name of your group below
%
\centerline{\large Authors:}
\bigskip
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% AUTHORS
% Change the name of the Group participants here
%
\centerline{\large Marco Magliona}
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\vspace{2cm}
\centerline{\large \today}
\end{titlepage}

\setcounter{secnumdepth}{3}
\setcounter{tocdepth}{3}
\tableofcontents

\mainmatter

% Custom commands
\newcommand{\shellcmd}[1]{\texttt{\footnotesize\ \mbox{#1}}}
%Insert a dia generated diagram, first parameter is filename, second is caption, third is ref_name, forth is left padding, fifth is width
\newcommand{\dia}[5]{
\begin{figure}[H]
	\begin{center}
		\hspace*{#4cm}
		\resizebox{#5\textwidth}{!}{\input{./chapters/diagrams/#1.tex}}
		\caption{#2}
		\label{#3}
	\end{center}
\end{figure}
}

\newmintedfile[vhdlcode]{vhdl}{breaklines, fontsize=\scriptsize}

% Insert vhdl, first parameter is filename, second is first line, third is last line, fourth is leading characters to remove, fifth is the caption, sixth is the label
\newcommand{\inputvhdl}[6]{
	\begin{listing}[H]
		\vhdlcode[firstline=#2, lastline=#3, gobble=#4]{../Src/DLX_vhd/#1}
		\caption{#5}
		\label{#6}
	\end{listing}
}

\newmintedfile[tclcode]{tcl}{breaklines, fontsize=\scriptsize}
\newcommand{\inputtcl}[6]{
	\begin{listing}[H]
		\tclcode[firstline=#2, lastline=#3, gobble=#4]{../Src/DLX_vhd/#1}
		\caption{#5}
		\label{#6}
	\end{listing}
}

\newmintedfile[plaintext]{bash}{breaklines}
\newcommand{\inputtext}[4]{
	\begin{listing}[H]
		\plaintext[gobble=#2]{./#1}
		\caption{#3}
		\label{#4}
	\end{listing}
}

% Insert a picture, first item is the name, second is caption, third is label, and forth is resizing
\newcommand{\inputfigure}[4]{
	\begin{figure}[H]
		\centering
		\includegraphics[scale=#4]{./chapters/figures/#1}
		\caption{#2}
		\label{#3}
	\end{figure}
}


\providecommand*{\listingautorefname}{Listing}
% Generate diagrams
% \immediate\write18{./chapters/diagrams/diagrams_generate.sh}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%    
% HERE IS WHERE YOU INCLUDE YOUR CHAPTERS
%
\input{./chapters/chap1}
\input{./chapters/chap2}
\input{./chapters/chap3}
\input{./chapters/chap4}
\input{./chapters/chap5}
\input{./chapters/chap6}
% \input{./chapters/chap7}

\newpage
\vspace*{\fill}
Written in \LaTeX \space using Vim 8.0 with \emph{vimtex} plugin. Compiled with latexmk and the packages from \TeX Live 2016.
% \input{./chapters/chap_name}
% and so on
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%    
% HERE IS WHERE YOU INCLUDE YOUR APPENDICES (IF ANY)
%
\appendix
%\input{./appendices/appendix1}
% \input{./appendices/appendix2}
% and so on
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\end{document}
